# 外部境界のテストのサンプルコード

「外部境界のテスト ── H2でDBアクセス、SubEtha SMTPでメール送信環境を擬似的に作り出す」のサンプルコードです。

## Eclipseへのインポート

次のコマンドを実行してからインポートしてください。

```
./gradlew eclipse
```

Windowsの場合は次のコマンドになります。

```
gradlew.bat eclipse
```

## サンプルコードのファイル構成

```
LICENSE                 このサンプルコードのライセンスです
README.md               このファイルです
build.gradle            Gradleのビルドスクリプトです
gradle                  Gradleが使用するファイルが格納されています
gradlew                 Gradleの起動スクリプトです
gradlew.bat             Gradleの起動スクリプトです(Windows用)
settings.gradle         Gradleが使用するプロジェクトの設定ファイルです
db-sample
└── src
    ├── main
    │   └── java
    │       └── sample
    │           └── dao
    │               ├── ProgrammerDao.java          DBアクセスを行うプロダクションコードのサンプルです
    │               └── impl
    │                   └── ProgrammerDaoImpl.java  ProgrammerDaoの実装クラスです
    └── test
        ├── java
        │   └── sample
        │       ├── rule
        │       │   └── InMemoryH2.java             H2を使うためのTestRule実装クラスです
        │       └── test
        │           ├── DataSourceTest.java         javax.sql.DataSourceを使うテストのサンプルです
        │           ├── DbUnitTest.java             DbUnitを利用したテストデータ投入とアサーションのサンプルです
        │           └── ProgrammerDaoImplTest.java  InMemoryH2を利用した単純なテストのサンプルです
        └── resources
            ├── data.xlsx                           DbUnitで使用する、テストデータが書かれたExcelブックです
            ├── expected.xlsx                       DbUnitで使用する、期待値が書かれたExcelブックです
            └── setup.sql                           テスト対象のテーブルを準備するSQLです
mail-sample
└── src
    ├── main
    │   └── java
    │       └── sample
    │           └── MailSender.java    メール送信を行うプロダクションコードのサンプルです
    └── test
        └── java
            └── sample
                ├── rule
                │   └── MockSMTP.java  SubEtha SMTPのWiserを使うためのTestRule実装クラスです
                └── test
                    └── MailTest.java  メール送信のテストのサンプルです
```

## ライセンス

このサンプルコード一式は[The MIT License](https://opensource.org/licenses/MIT)のもとに提供します。

## 作者

のざき、うらがみ
