package sample.dao.impl;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Optional;

import sample.dao.ProgrammerDao;

public class ProgrammerDaoImpl implements ProgrammerDao {

    private final Connection con;

    public ProgrammerDaoImpl(final Connection con) {
        this.con = con;
    }

    @Override
    public Optional<String> findNameByGitHubId(final String gitHubId) throws SQLException {
        final String sql = "SELECT name FROM programmer WHERE github_id = ?";
        try (PreparedStatement pst = con.prepareStatement(sql)) {
            pst.setString(1, gitHubId);
            try (ResultSet rs = pst.executeQuery()) {
                if (rs.next() == false) {
                    return Optional.empty();
                }
                final String name = rs.getString("name");
                if (rs.next()) {
                    throw new RuntimeException();
                }
                return Optional.ofNullable(name);
            }
        }
    }
}
