package sample.rule;

import java.sql.Connection;
import java.sql.DriverManager;

import org.junit.rules.TestRule;
import org.junit.runner.Description;
import org.junit.runners.model.Statement;

public class InMemoryH2 implements TestRule {

    private Connection con;

    @Override
    public Statement apply(final Statement base, final Description description) {
        return new Statement() {
            @Override
            public void evaluate() throws Throwable {
                try (Connection con = DriverManager
                        .getConnection(
                                "jdbc:h2:mem:test;DB_CLOSE_DELAY=-1;INIT=RUNSCRIPT FROM 'classpath:setup.sql'")) {
                    InMemoryH2.this.con = con;
                    base.evaluate();
                }
            }
        };
    }

    public Connection getConnection() {
        return con;
    }
}
