package sample.test;

import static org.assertj.core.api.Assertions.*;

import java.sql.Connection;

import javax.sql.DataSource;

import org.h2.jdbcx.JdbcDataSource;
import org.junit.Before;
import org.junit.Test;

/**
 * {@link DataSource}を使用するテストのサンプルです。
 *
 */
public class DataSourceTest {

    private DataSource dataSource;

    @Before
    public void setUp() {
        final String url = "jdbc:h2:mem:test;DB_CLOSE_DELAY=-1;INIT=RUNSCRIPT FROM 'classpath:setup.sql'";

        //H2に含まれるDataSourceの実装クラス
        final JdbcDataSource jdbcDataSource = new JdbcDataSource();
        jdbcDataSource.setUrl(url);

        this.dataSource = jdbcDataSource;
    }

    @Test
    public void test() throws Exception {
        try (final Connection con = dataSource.getConnection()) {
            //DataSourceからConnectionが取得出来ることを確認
            assertThat(con).isNotNull();
        }
    }
}
