package sample.test;

import static org.assertj.core.api.Assertions.*;

import java.util.Optional;

import org.junit.Rule;
import org.junit.Test;

import sample.dao.impl.ProgrammerDaoImpl;
import sample.rule.InMemoryH2;

/**
 * InMemoryH2を利用した単純なテストのサンプルです。
 * 
 */
public class ProgrammerDaoImplTest {

    @Rule
    public InMemoryH2 h2 = new InMemoryH2();

    @Test
    public void findNameByGitHubId() throws Exception {

        final ProgrammerDaoImpl daoImpl = new ProgrammerDaoImpl(h2.getConnection());

        final Optional<String> name = daoImpl.findNameByGitHubId("backpaper0");

        assertThat(name).isPresent().hasValue("うらがみ");
    }
}
