package sample.rule;

import org.junit.rules.TestRule;
import org.junit.runner.Description;
import org.junit.runners.model.Statement;
import org.subethamail.wiser.Wiser;

public class MockSMTP implements TestRule {

    private final Wiser wiser;

    public MockSMTP(final int port) {
        this.wiser = new Wiser(port);
    }

    @Override
    public Statement apply(final Statement base, final Description description) {
        return new Statement() {
            @Override
            public void evaluate() throws Throwable {
                wiser.start();
                try {
                    base.evaluate();
                } finally {
                    wiser.stop();
                }
            }
        };
    }

    public Wiser getWiser() {
        return wiser;
    }
}